using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace HDC
{
	public partial class Form1 : Form
	{
		[DllImport("gdi32.dll")]
		public static extern bool BitBlt(IntPtr hObject, int nXDest, int nYDest, int nWidth,
		   int nHeight, IntPtr hObjSource, int nXSrc, int nYSrc, TernaryRasterOperations dwRop);

		[DllImport("gdi32.dll", ExactSpelling = true, SetLastError = true)]
		static extern IntPtr CreateCompatibleDC(IntPtr hdc);

		[DllImport("gdi32.dll", ExactSpelling = true, SetLastError = true)]
		static extern bool DeleteDC(IntPtr hdc);

		[DllImport("gdi32.dll", ExactSpelling = true, SetLastError = true)]
		static extern IntPtr SelectObject(IntPtr hdc, IntPtr hgdiobj);

		[DllImport("gdi32.dll", ExactSpelling = true, SetLastError = true)]
		static extern bool DeleteObject(IntPtr hObject);

		[DllImport("gdi32.dll")]
		static extern IntPtr CreateCompatibleBitmap(IntPtr hdc, int nWidth, int nHeight);

		public enum TernaryRasterOperations : uint
		{
			SRCCOPY = 0x00CC0020,
			SRCPAINT = 0x00EE0086,
			SRCAND = 0x008800C6,
			SRCINVERT = 0x00660046,
			SRCERASE = 0x00440328,
			NOTSRCCOPY = 0x00330008,
			NOTSRCERASE = 0x001100A6,
			MERGECOPY = 0x00C000CA,
			MERGEPAINT = 0x00BB0226,
			PATCOPY = 0x00F00021,
			PATPAINT = 0x00FB0A09,
			PATINVERT = 0x005A0049,
			DSTINVERT = 0x00550009,
			BLACKNESS = 0x00000042,
			WHITENESS = 0x00FF0062
		}


		IntPtr memHdc;
		IntPtr hBitmap;


		public Form1()
		{
			InitializeComponent();
		}	

		private void btDraw_Click(object sender, EventArgs e)
		{
			DrawSomething();
			MoveFromMemory(Graphics.FromHwnd(pictureBox1.Handle));
		}

		private void btSave_Click(object sender, EventArgs e)
		{
			//odavde snimas na disk
			Image i = Image.FromHbitmap(hBitmap);
			i.Save(@"D:\test.bmp");
		}

		private void pictureBox1_Paint(object sender, PaintEventArgs e)
		{
			MoveFromMemory(e.Graphics);	
		}

		private void Form1_Shown(object sender, EventArgs e)
		{
			Graphics g = Graphics.FromHwnd(pictureBox1.Handle);
			IntPtr hdc = g.GetHdc();

			memHdc = CreateCompatibleDC(hdc);
			hBitmap = CreateCompatibleBitmap(hdc, pictureBox1.Width, pictureBox1.Height);
			SelectObject(memHdc, hBitmap);
			g.ReleaseHdc(hdc);

			DrawSomething();
		}

		private void Form1_FormClosed(object sender, FormClosedEventArgs e)
		{
			DeleteObject(hBitmap);
			DeleteDC(memHdc);
		}	
		
		void MoveFromMemory(Graphics g)
		{
			IntPtr picHdc = g.GetHdc();
			BitBlt(picHdc, 0, 0, pictureBox1.Width, pictureBox1.Height, memHdc, 0, 0, TernaryRasterOperations.SRCCOPY);
			g.ReleaseHdc(picHdc);
		}

		void DrawSomething()
		{
			Graphics g = Graphics.FromHdc(memHdc);
			g.FillRectangle(Brushes.Blue, new Rectangle(0, 0, pictureBox1.Width, pictureBox1.Height));
			g.FillRectangle(Brushes.Red, new Rectangle(20, 20, pictureBox1.Width - 40, pictureBox1.Height - 40));
			Random rnd = new Random();


			// malo random iscrtavanja :)
			for (int i = 0; i < 20; i++)
			{					
				SolidBrush solidBrush = new SolidBrush(Color.FromArgb(rnd.Next(255), rnd.Next(255), rnd.Next(255)));
				Rectangle rect = new Rectangle(rnd.Next(100), rnd.Next(100), rnd.Next(pictureBox1.Width) + 1, rnd.Next(pictureBox1.Height) + 1);
				g.FillRectangle(solidBrush, rect);
			}
		}		
	}
}